#ifndef WORLD_HH
#define WORLD_HH

#include "heightfield.hh"
#include "geometry.hh"

struct World {
  const int xsize, ysize;
  HeightField rock, water;

  World(int xsize, int ysize);
  inline float get_height(int x, int y) const {
    return rock.height(x, y) + water.height(x, y);
  }
  inline vec3 get_point(int x, int y) const {
    return vec3(x, y, get_height(x, y));
  }
  vec3 normal(int x, int y) const;
  vec2 gradient(const vec2 &p) const;
  void update();
};

#endif
